<?php
/*
 Plugin Name: EpsilonWriter Editor
 Plugin URI: http://www.epsilonwriter.com/
 Description: Enables EpsilonWriter features in TinyMCE, the visual editor in WordPress.
 Version: 0.2
 Author: Christophe Viudez Aristod
 Author URI: http://www.aristod.com/
 License: 
 License URI: 
 Text Domain: aristod-epsilonwriter-editor
 Domain Path: /langs

 Copyright (c) 2017 Aristod. All rights reserved.
 */

//avoid wp adding p tags
remove_filter('the_content', 'wpautop');
remove_filter('the_excerpt', 'wpautop');


//
// gets the author role and adding author unfiltered_html
$role = get_role( 'author' );
$role -> add_cap( 'unfiltered_html' );
///


add_action( 'plugins_loaded', 'epsilonwriter_load_textdomain' );

/**
 * Load plugin textdomain.
*/
function epsilonwriter_load_textdomain() {
	load_plugin_textdomain( 'aristod-epsilonwriter-editor', false);
}



/*
 * TinyMCE settings
 */
function epsilonwriter_setting_TinyMCE( $in ) {
	$in['content_css'] ='http://www.epsilonwriter.com/epsi2/EpsiWriter.css';
	$in['entity_encoding']='raw';
	$in['encoding']='UTF-8';
	$in['extended_valid_elements'].=',span[*],math[*],menclose[*],merror[*],mfenced[*],mfrac[*],mglyph[*],mi[*],mlabeledtr[*],mmultiscripts[*],mn[*],mo[*],mover[*],mpadded[*],mphantom[*],mroot[*],mrow[*],ms[*],mspace[*],msqrt[*],mstyle[*],msub[*],msubsup[*],msup[*],mtable[*],mtd[*],mtext[*],mtr[*],munder[*],munderover[*],semantics[*],maction[*]';
	return $in;
}
add_filter( 'tiny_mce_before_init', 'epsilonwriter_setting_TinyMCE' );


// Load the TinyMCE plugin 
add_filter( 'mce_external_plugins', 'epsilonwriter_tinymce_plugin_register' );

function epsilonwriter_tinymce_plugin_register( $plugin_array ) {
	$plugin_array['epsilon_wp'] = plugins_url( 'js/epsilon_wp/plugin.min.js',__FILE__ );
	return $plugin_array;
}


add_filter( 'mce_buttons', 'epsilonwriter_register_buttons' ); //adding tinyMCE plugin buttons

function epsilonwriter_register_buttons( $buttons ) {
	array_push( $buttons, 'separator', 'epsilon');
	return $buttons;
}

add_filter( 'mce_buttons_', 'epsilonwriter_register_buttons' );



add_action( 'edit_form_after_title', 'epsilonwriter_edit_form_after_title' );


function epsilonwriter_before_bdupdate( $content ) {
	$custom_content="";
	try {
		$custom_content .= $_POST['ewcontent'];
		if(! empty($custom_content)) return $custom_content;
		else return $content;
	} catch (Exception $e) {
		$custom_content="";
	}
	
	return $content;
}

add_filter( 'content_save_pre', 'epsilonwriter_before_bdupdate', 10, 1 );


//LOCALE
/**
 * Return the locale to value given by dedicated epsilonwriter script.
 */




function epsilonwriter_edit_form_after_title() {
	$locew=get_user_locale();
	$langew=substr(get_user_locale(),0,2);
	?>
	<script type="text/javascript">
	var ew_width=600;
	var ew_height=500;
	var txtCopy="";
	var lastEdit="";
	var validated=false;
	var language='<?php echo $langew?>';
	var ew_edited="";
	var ew_ready=false;

	var in_el=document.createElement("input");
	in_el.setAttribute("type","hidden");
	in_el.setAttribute("name","ewcontent");
	in_el.setAttribute("id","ewcontent_input");
	document.getElementById("post").appendChild(in_el);	

	//Function update_lang
	//param lang: 2 letters language code ex: "fr", "en"
	//Updating texts of the page only
	function update_lang(lang){        
	    language=lang;
	    }

	update_lang(language);
	function langueNavigateur(){
	return language;
	}
	//**** END LANGUAGES MANAGEMENT
	</script>
	<?php 
	wp_enqueue_style('epsiwriter_epsi_css','http://epsilonwriter.com/epsi2/EpsiWriter.css');
	wp_enqueue_script('epsiwriter_native','http://epsilonwriter.com/epsi2/natives.js');
	
	/*global $langwp;
	
	$langwp=wp_enqueue_script('epsiwriter_lang','http://epsilonwriter.com/epsi2/get_stored_lang.js');
	
	echo "<h2>Lang :".$langwp."</h2>";
	
	$epsilonwriter_cancel='Cancel';
	$epsilonwriter_save='Save';
	$epsilonwriter_alert_quit_message='Quit editing \n\ (changes will be lost) ?';
	
	if($langwp=='fr'){
	$epsilonwriter_cancel='Annuler';
	$epsilonwriter_save='Enregistrer';
	$epsilonwriter_alert_quit_message='Quitter l\'édition \n\ (les modifications seront perdues) ?';
	}*/
	
	
	/*function epsilonwriter_change_language( $locale )
	{
		if($langwp==='fr')return 'fr_FR';
		else return $locale;
	}
	add_filter( 'locale', 'epsilonwriter_change_language');*/
	
	
	?>
<!-- Basic Modal window (TODO improve UI) -->
<div id="openModal" class="ew_modal">
<div class="ew_modal-container">
    <div class="ew_modal-header">EpsilonWriter</div>  
  	<div id="panfull">
    <button id="fullscreen"><img id="icofullscreen" src="http://epsilonwriter.com/epsi2/images/iconfullscreen.png"/></button>
	</div> 
    <div id="infobody" class="ew_modal-body" width="600px" height="500px">
    </div>
    <div class="ew_modal-footer">
        <button type="button" onclick="close_modal(false);"><?php _e("cancel","aristod-epsilonwriter-editor"); ?></button>
        <button type="button" onclick="epsiwriter_execute('save_raw','tinymce');"><span class="glyphicon glyphicon-ok"></span> <?php _e("save","aristod-epsilonwriter-editor"); ?></button>
    </div>	
</div>
</div>
	<?php 
	wp_enqueue_script('epsiwriter','http://epsilonwriter.com/epsi4/epsiwriterplugin/epsiwriterplugin.nocache.js');
	?>

	<script>


//Update content using content from EpsiWriter (ncontent)
function updateContent(ncontent){
ew_edited=ncontent;
ncontent=ncontent.trim();
ncontent=ncontent.replace(/r?\n|\r/g,"");

document.getElementById('ewcontent_input').value=ncontent;
}

//Display modal element
function displayModal(){
var modal = document.getElementById('openModal');
modal.style.display = "block";
modal.style.visibility="visible";
var panfull = document.getElementById('panfull');
panfull.style.display = "none";
panfull.style.visibility="hidden";
}

//close modal element
function close_modal(is_saved_before){
if(is_saved_before){
    document.getElementById("openModal").style.display="none";
    document.getElementById("openModal").style.visibility="hidden";
}
else{
if(window.confirm("<?php _e("alert_quit_message","aristod-epsilonwriter-editor"); ?>")){
document.getElementById("openModal").style.display="none";
document.getElementById("openModal").style.visibility="hidden";
return true;    
}
else {
displayModal();  
}
}
}

//Importing content from post to tinyMCE
function fromPageToTinyMCE(){
var htmlcontent=tinymce.activeEditor.getContent();
epsiwriter_execute('toTinyMCE',htmlcontent);
}

/*
 * Called by EpsilonWriter to put all the content in TinyMCE
 * @param {type} newcontent
 * @returns {undefined}
 */
function epsiwriter_getFromEpsiWriterToTinyMCE(newcontent){
    tinymce.activeEditor.setContent(newcontent,{format: 'raw'});
}

function epsiwriter_getEditedFromEpsiWriterToTinyMCE(newcontent){
	tinymce.activeEditor.selection.setContent(newcontent,{format: 'raw'});
    close_modal(true);
}

function epsiwriter_set_ready(){
ew_ready=true;
}	
</script>	
	<?php 
}